'
'	Frank Lupo (Wolf) !!
'	frank_lupo@email.it
'
'	This is a Psql command for Postgresql write in Visual Basic Script
'
'	Class Print
'	Print result of record set
'
Option Explicit

Class ClsPrint
	Public Title
	Public DisplayNumRow
	Public Html
	Public PrintRowsOnly
	Private szFileSendResultsQuery 
'''	Public RecordSeparator
'''	Public FieldSeparator

'*********************
'*********************
'*********************
	Private SEPCOLUMN
	Private SEPCOLUMN1
	Private SEPHEADER
'*********************
'*********************
'*********************


	Public Property Let FileSendResultsQuery(vData)
		szFileSendResultsQuery=vData
		if len(szFileSendResultsQuery) > 0 then App.Data.Utility.FileSystem.DeleteFile szFileSendResultsQuery
	End Property

	Private Sub Class_Initialize
		DisplayNumRow=True
		Html=False
		PrintRowsOnly=False
		FileSendResultsQuery =""

'*********************
'*********************
'*********************
		SEPCOLUMN="|"
		SEPCOLUMN1="+"
		SEPHEADER="-"
'*********************
'*********************
'*********************

  	End Sub

	'Print result using recordset retuned of query
	Public Sub PrintResultSQL()
	Dim Field,ResultSet,szTemp,szCells,iRow,iCol,iLenCol,szTemp1,iNumChr,szAlign
	Dim iWindowHeight,iRowInVis,bFristPage,iNumRec,szSqlCommand,vData,iLng,szHeader,szFooter

		Set ResultSet=App.Data.ConDb.ResultSet

		If ResultSet Is nothing Then exit sub

		'Verify command sql
		if ResultSet.Fields.Count <=0 then
			szTemp=trim(ucase(App.Data.ConDb.SqlIstr))
			vData=split(ucase(szTemp))
			if vdata(0)="UPDATE" then
				EchoStirng "UPDATE " & iNumRec
			elseif vdata(0)="INSERT" then
				EchoStirng "INSERT " & iNumRec
			else
				szSqlCommand=Array("ALTER","COMMENT","CREATE","DROP","VACUUM")
				for each szTemp1 in szSqlCommand
					if vData(0)=szTemp1 then 
						szTemp=vData(0) 
						if ubound(vData) > 0 then szTemp=szTemp & " " & vData(1)
						EchoStirng szTemp
						exit for
					end if 
				next
			end if
			exit sub
		end if


		bFristPage=True
		iWindowHeight=App.Data.Shell.Height
		iNumRec=App.Data.ConDb.NumRow

		Redim iLenCol(ResultSet.Fields.Count)

		'Calculate the size of column using value of column
		If Not Html then 
			if iNumRec > 0 then
				While Not ResultSet.Eof
					iCol=0
					For Each Field in ResultSet.Fields
						iLng=len(Field.Value)
						If iLenCol(iCol) < iLng Then iLenCol(iCol)=iLng
						iCol=iCol+1
					Next
					ResultSet.MoveNext
				Wend
				ResultSet.MoveFirst
			end if
		End if

		iNumChr=0
		redim szHeader(ResultSet.Fields.Count-1)
		iCol=0
		For Each Field in ResultSet.Fields
			szHeader(iCol)=Field.Name
			iCol=iCol+1
		Next

		CreateHeader szHeader,iLenCol,iNumChr,szTemp,szTemp1 

		'Alignment
		redim szAlign(ResultSet.Fields.Count-1)
		iCol=0
		For Each Field in ResultSet.Fields
			If Field.type = adBigInt or _
				Field.type = adBinary or _
				Field.type = adBoolean or _
				Field.type = adCurrency or _
				Field.type = adDecimal or _
				Field.type = adDouble or _
				Field.type = adInteger or _
				Field.type = adNumeric or _
				Field.type = adSingle or _
				Field.type = adSmallInt or _
				Field.type = adTinyInt or _
				Field.type = adUnsignedBigInt or _
				Field.type = adUnsignedInt or _
				Field.type = adUnsignedSmallInt or _
				Field.type = adUnsignedTinyInt Then
				szAlign(iCol)="R"
			Else
				szAlign(iCol)="L"
			End If
			iCol=iCol+1
		Next

		'Print Title
		PrintTitle Title,iNumChr

		'Print Header
		PrintHeader szTemp,szTemp1

		'Loop recordset
		While Not ResultSet.Eof
			'Calculate the size of column using value column
			iRowInVis=App.Data.Utility.Math.Min(iWindowHeight,iNumRec)-1
			iNumRec=iNumRec-iRowInVis-1

			If iRowInVis >= iWindowHeight Then
				If bFristPage Then 
					iRowInVis=iRowInVis-2
					if len(Title) > 0 then iRowInVis=iRowInVis-1
				end if
			End If

			'Load cells
			Redim szCells(iRowInVis,ResultSet.Fields.Count-1)
			iRow=0
			While Not ResultSet.Eof and iRowInVis >= iRow
				iCol=0
				For Each Field in ResultSet.Fields
					szCells(iRow,iCol)=Field.Value
					iCol=iCol+1
				Next
				ResultSet.MoveNext
				iRow=iRow+1
			Wend

			'Print cells
			PrintCells szCells,szAlign,iLenCol

			If Not ResultSet.Eof Then
				'Verify if command is execute from line command
				if Not App.Data.Setting.CmdFromLineCommand Then
					if len(szFileSendResultsQuery) = 0 then
						'More Page
						Wscript.StdOut.Write ":"
						szTemp= WScript.StdIn.ReadLine
						If lcase(left(trim(szTemp),1))="q" then 
							exit sub 
						End if
					End if
				End if
			End If
			bFristPage=False
		Wend

		If Not PrintRowsOnly then
			if DisplayNumRow then
				redim szFooter(0)
				szFooter(0)=App.Data.Message.Row(App.Data.ConDb.NumRow)
				PrintFooter(szFooter)
			end if
		End if
	End Sub

	Private Sub EchoStirng(Istr)
		if len(szFileSendResultsQuery) >0 then
			'Echo file
			App.Data.Utility.FileSystem.WriteFile szFileSendResultsQuery,Istr & vbcrlf ,ForAppending
		else
			'Echo screen
			Wscript.Echo Istr
		end if
	End Sub

	'Print Title of output
	Private Sub PrintTitle(Title,LngPrint)
		If not PrintRowsOnly then
			If Html Then
				EchoStirng "<table border=1>"
				If len(trim(Title)) > 0 Then EchoStirng "  <caption>" & Title & "</caption>"
			Else
				If len(trim(Title)) > 0 Then EchoStirng App.Data.Utility.String.CenterStr(Title,LngPrint)
			End If
		End if
	End Sub

	'Print header
	Private Sub PrintHeader(StringHeader,StringSeparetor)
		If not PrintRowsOnly then
			If Html Then
				EchoStirng "  <tr>"
				EchoStirng StringHeader
				EchoStirng "  </tr>"
			Else
				EchoStirng StringHeader					' Name column
				EchoStirng StringSeparetor				' Separator
			End If
		End if
	End Sub

	'Print footer
	Private Sub PrintFooter(Footer)
	Dim ii,szTemp

		If Html then EchoStirng "</table>" 
		for ii=lbound(Footer) to ubound(Footer)
			szTemp=Footer(ii)
			If Html then szTemp=szTemp & "<br>"
			EchoStirng szTemp
		next 

		EchoStirng ""
	End Sub

	'Create header
	Private Sub CreateHeader(Header,iLenCol,iNumChr,StringHeader,StringSeparetor)
	Dim ii,iLng
	
		StringHeader=""
		StringSeparetor=""
		for ii=lbound(Header) to ubound(Header)
			If Html then
				StringHeader=StringHeader & "    <th align=center>" & Header(ii) & "</th>"
			Else
				iLng=Len(Header(ii))
				If iLenCol(ii) < iLng Then iLenCol(ii)=iLng
				StringHeader=StringHeader & App.Data.Utility.String.CenterStr(Header(ii),iLenCol(ii)+2)
				StringSeparetor=StringSeparetor & String(iLenCol(ii)+2, SEPHEADER)
				iNumChr=iNumChr+iLenCol(ii)+1
			End if

			If ii < ubound(Header) Then 
				If Html then
					StringHeader=StringHeader & Vbcrlf
				Else
					StringHeader=StringHeader & SEPCOLUMN	
					StringSeparetor=StringSeparetor & SEPCOLUMN1
					iNumChr=iNumChr+2
				End if
			End If
		Next
	End Sub


	'Print Cells
	Private Sub PrintCells(Cells,Align,LenCol)
	dim iRow,iCol,iCol_l,iCol_u,szTemp

		iCol_l=lbound(Cells,2)
		iCol_u=ubound(Cells,2)

		for iRow=lbound(Cells,1) to ubound(Cells,1)
			If Html Then
				szTemp="  <tr valign=top>" & vbcrlf
			Else
				szTemp=""
			End if

			for iCol=iCol_l to iCol_u
				If Html Then
					If Align(icol)="L" Then
						szTemp=szTemp & "    <td align=left>" 
					elseIf Align(icol)="R" Then
						szTemp=szTemp & "    <td align=right>"
					End If
					szTemp=szTemp & Cells(iRow,iCol) & "</td>" & vbcrlf
				Else
					If Align(icol)="L" Then
						szTemp=szTemp & " " & Left(Cells(iRow,iCol) & String(LenCol(iCol), " "), LenCol(iCol))
					elseIf Align(icol)="R" Then
						szTemp=szTemp & " " & String(LenCol(iCol)-len(Cells(iRow,iCol)), " ") & Cells(iRow,iCol)
					End If
					If iCol < iCol_u Then szTemp=szTemp & " " & SEPCOLUMN
				End if
			Next 
			If Html Then szTemp=szTemp & "  </tr>" 
			EchoStirng szTemp
		next
	End Sub

	'Print result of no query
	Public Sub PrintResultNoSQL(Title,Headers,Cells,Footer)
		Dim szAlign,iLenCol,iCol,iRow,iCol_l,iCol_u,iLng,iNumChr,szTemp,szTemp1 

		redim iLenCol(ubound(Headers))
		iCol_l=lbound(cells,2)
		iCol_u=ubound(cells,2)

		'Calculate the size of column using value of column
		for iRow=lbound(cells,1) to ubound(cells,1)
			for iCol=iCol_l to iCol_u
				iLng=len(cells(irow,icol))
				if iLenCol(icol) < iLng then iLenCol(icol)=iLng
			next 
		next

		'Set Align
		redim szAlign(ubound(Headers))
		for iCol=lbound(szAlign) to ubound(szAlign)
			iLng=len(Headers(iCol))
			if iLenCol(icol) < iLng then iLenCol(icol)=iLng
			szAlign(iCol)="L"
		next 

		'print
		iNumChr=0
		CreateHeader Headers,iLenCol,iNumChr,szTemp,szTemp1 

		PrintTitle Title,iNumChr
		PrintHeader szTemp,szTemp1
		PrintCells Cells,szAlign,iLenCol
		PrintFooter Footer
	End Sub
End Class
